/*
   THE SnAkEsSoFt Assembler v3.0.BETA

     By snakesoft/Rodney McConnell

      (c)2001-rewrite of the front bit(uses the sam ASM2HEX I had written b4)      
      rewrite bit(30June - 10July)

      The SLINK/SOB weren't linkin too good, soo decided to rewrite...

SOB code:
## comment
#oxxLABEL offset access  xx=mathsym,size
#sxxLABEL segment access xx=mathsym,size
#rX relativeoffset(X==size)
#dX xxxx directive X xxxx
#SxLABEL define segment x=size
#OxLABEL define offset: x=size
#ELABEL extern label
#dxx directive (stack etc...)

UPDATE:
 make it easier to include SASM routines in another prog, Eg: SCC
 Perhaps locals/gobals

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#define SASM_ID_     0x13
#define SASM_ver_    "3.0Beta"
#define SASM_vernum_ 30

#define BYTE unsigned char
#define Pmode out32

//#include "sasm.h"



int findmarco(char *name);
int finddirective(char *name);
int dofind_equ(char *name);
void error(char *str, int err);
void store_byte(unsigned char byt);
void add_relative_mark(int size);
void addlabeloffsetstore(unsigned long offset,int type, int mathsym, char *name, int size);


#define LOWBYTE(x)  ((x) & 0xff)
#define HIGHBYTE(x) (((x) >> 8) & 0xff)

#define ERROR 0
#define WARNING 1

//how much to malloc at a time for the program code
//#define code_step 0x100

#define MAXASMLINE 151
#define MAXWORDLEN 121
#define MAX_LABEL_SIZE   MAXWORDLEN+4

#define off_set code_ptr
#define write_inst store_byte

#define errcnt error_cnt
#define warcnt warning_cnt

int error_cnt,warning_cnt, total_err=0,total_warn=0;
int linecntr, total_linecntr=0;


unsigned long stack_seg;
unsigned long stack_size;
unsigned long set_mem_max;
unsigned long start_seg;
unsigned long start_offset;

unsigned long org_offset=0;

unsigned long code_ptr;//this is where we take the next address from
unsigned long seg_code_ptr;
unsigned long real_code_ptr=0;//this is the place in our memory

int currentseg=0; //oursegment total


char lose_nodata_error=0;

//unsigned char *the_code=NULL;
unsigned long code_size=0;

short mem_model=2;
unsigned char out32=0,hadoverwarn=0,make32=0;
short out_type=0;//1=com, 2=lib
      
short case_sensi=0;

short out_of_mem=0;
int malfreecntr=0;

FILE *cur_file=NULL;
FILE *our_outfile=NULL;
int lptr,endof;

char curline[257];
char theword[257];


#include "sasm_it.c"


FILE *re_hnd=NULL;
char re_dir=0;
char *re_name=NULL;
char pr_str[255];
void print_f(char *str){
 if(re_dir==0)printf("%s",str);
 else if(re_hnd)fprintf(re_hnd,"%s",str);
return; }


void defaults(){
        stack_seg=0xffff;
	stack_size=0x200;
	set_mem_max=0xFFFF;
	start_seg=0;
	start_offset=0;
        org_offset=0;
        lose_nodata_error=0;
        if(out_type==1)org_offset=0x100;//com file default
	
	code_ptr=0;
        seg_code_ptr=0;
	real_code_ptr=0;//this is the place in our memory
	currentseg=0;
return; }


typedef struct table_relative{ //  JMP displacement...
//the linker adds the address it's at to the value already there(or something)
    		  short size;//(1)8,(2)16,(3)32 address
    		  unsigned long offset;//where it started
    		  struct table_relative *prev;
				}table_relative;
table_relative *top_relat=NULL;

void free_relatives(){
table_relative *tp;
	while(top_relat){
				  tp=top_relat->prev;
				  free(top_relat);
				   malfreecntr--;
	               top_relat=tp;
					}
return; }

void add_relative_mark(int size){ //these are for IP-/+
  table_relative *fs;  
  if(size==0)size=3;//this is the way do_number handles it
  
  fs=(table_relative *)malloc(sizeof(table_relative));
  if(fs==NULL){ out_of_mem=1; return; }
  malfreecntr++;
  fs->prev=top_relat;
  top_relat=fs;
  fs->size=size;
//  fs->offset=code_ptr;
  fs->offset=real_code_ptr;
// printf(" (relative number %ud (size=%d)) ",off_set,8*size);

  fprintf(our_outfile,"\n#r%d",size);
return; }


typedef struct inc_stack{
			int linecntr;
			char *name;
			FILE *hnd;
			struct inc_stack *prev;
			}inc_stack;
inc_stack *top_inc=NULL;


void error(char *str, int err){
 if(err==ERROR){
 	error_cnt++; total_err++;
        if(top_inc==NULL) sprintf(pr_str,"ERROR: %s (Line %d)\n",str,linecntr);
        else sprintf(pr_str,"ERROR: in included file \"%s\"\n     %s (Line %d)\n",top_inc->name,str,linecntr);
        print_f(pr_str);
 			}
 else{
 warning_cnt++; total_warn++;
 if(top_inc==NULL) sprintf(pr_str,"WARNING: %s (Line %d)\n",str,linecntr);
 else sprintf(pr_str,"WARNING: in included file \"%s\"\n       %s (Line %d)\n",top_inc->name,str,linecntr);
 print_f(pr_str);
 		}			
return; }



char *directives[]={
                    "MARCO","ENDMARCO","EQU", 		//0,1,2
                    "PROC","SEG",                   //3,4
                    "START","SETMAX","ORG","STACK", //5,6,7,8
                    "INLINK","INCLUDE",             //9,10
                    "DB","DW","DD",                 //11,12,13
                    "DUB_DB","DUB_DW","DUB_DD",     //14,15,16
                    "STACKSEG",                     //17
                    "EXTERN",                       //18
                    //"LOCAL",                        //19
                    "",
                    "USE32","USE16","OUT32",        //20,21,22
                    "MODEL",                        //23
                    "OUTCOM","OUTLIB",              //24,25
                    "CASESENSI",                    //26
                    "ASSUMEDSCS",                   //27
                    NULL };


int findillegaldirective(int f_th, char *name){
 int a;
 
 a=finddirective(name);
 if(a>-1){  switch(a){
   				 case 1: return 0; //endmarco
 				 case 11: case 12: case 13:
 				 case 14: case 15: case 16:
 				 					if(f_th==0)return 0;//must be first thing
 				 					else return 1;
 				 					break;
 				 default:
 				 		return 1; 
 						}
 				}
return 0; }

int find_multi(char *str){
 int cnt=0;
 for(;;){
	 if(multi[cnt]==NULL)break;
	 if(!stricmp(multi[cnt],str))return cnt;
	 cnt++;
 		}
return -1; }


int ourskipspace(int cp, char *line){
 for(;;){
 	if(line[cp]!=32)break;
 	cp++;
 	}
return cp; }

int is_seg(char c1, char c2){
 if(toupper(c2)!='S')return -1;
 switch(toupper(c1)){
             case 'C': return 1;
             case 'D': return 2;
             case 'E': return 3;
             case 'F': return 4;
             case 'G': return 5;
             case 'S': return 6;
                }
return -1; }

void add_seg(int wh){
 switch(wh){
       case 1: store_byte(0x2e); break;
       case 2: store_byte(0x3e); break;
       case 3: store_byte(0x26); break;
       case 4: store_byte(0x64); break;
       case 5: store_byte(0x65); break;
       case 6: store_byte(0x36); break;
        }
return; }

void remove_seg_overrides(char *line){
 char k,o1,o2,o3;
 int place=0,seg;

 //find them
 for(;;){
       k=toupper(line[place]);
       if(k==0)break;
       if(k==':' && place>2){//has a :
                        o1=0; if(place>3)o1=line[place-3];
                        o2=line[place-2];
                        o3=line[place-1];
                        if(o1==0 || o1=='[' || o1==32 || o1==','){//has space before it
                                       seg=is_seg(o2,o3);
                                       if(seg>-1){//it was
                                              line[place-2]=32;
                                              line[place-1]=32;
                                              line[place]=32;
                                              add_seg(seg);
                                              break;
                                                        }
                                                }
                            }//:
        place++;
         }//loop
return; }

int assemble(char *line){
 int cp=0,cn,oc,tst;
 short k;
 
  for(;;){
   	cp=ourskipspace(cp,line);
   	cn=0; oc=cp;
   	for(;;){
   	      k=toupper(line[oc]);
          if(k<'A' || k>'Z')break;          
          theword[cn++]=k;
          oc++;
   			}
   	theword[cn]=0;
   	k=find_multi(theword);
   	if(k!=-1){ //printf("ASM line %s\n",multi[k]);
            strcpy(asm_str,multi[k]);
            tst=asm_main();// 0 okay, 1 Nothing to do(blank line), 2 had error
            fprintf(our_outfile,"\n");
            //if(tst==2)return -1;
   					}	
    else break;
    cp+=cn;
    	} 
  if(line[cp]!=0){//printf("ASM line %s\n",line+cp);
            remove_seg_overrides(line+cp);
            strcpy(asm_str,line+cp);
            tst=asm_main();// 0 okay, 1 Nothing to do(blank line), 2 had error
            fprintf(our_outfile,"\n");
            //if(tst==2)return -1;
            }


return 0; }


/*typedef struct access_st{
                unsigned long offset;
                int type;
                char mathsym;
                short siz;
                struct access_st *prev;
                                }access_st;*/
typedef struct lab_st{
				 char *name;
				 unsigned long offset;//where to find it
				 int type;//-1 not sure, 0=label, 1=procnear, 2=segment,// 3=EXTERN
				 int seg;//seg number to find it in
				 int siz;
                                 char islocal;
                                 //access_st *top_access;
                 struct lab_st *prev;
                 }lab_st;
lab_st *top_label=NULL, *tmp_label=NULL;

/*void free_access(access_st *top){
 access_st *tp;
 if(top==NULL)return;
 while(top){
 			tp=top->prev;
 			free(top); malfreecntr--;
 			top=tp;
 				}
return; }*/
void check_labels(){
 lab_st *tp=top_label;
 char str[50];
 while(tp){
          if(tp->type==-1){ sprintf(str,"Label %s not found",tp->name); error(str,ERROR); }
          tp=tp->prev;
 		  }
return; }
void free_labels(){
 lab_st *tp;
 while(top_label){
          tp=top_label->prev;
          if(top_label->name!=NULL){ free(top_label->name); malfreecntr--; }
          //free_access(top_label->top_access);
          free(top_label); malfreecntr--;
          top_label=tp;
 		  }
return; }

int find_label(char *name){
 tmp_label=top_label;
 while(tmp_label){
           if(case_sensi){
                        if(!strcmp(tmp_label->name,name))return 1;
                                }
           else if(!stricmp(tmp_label->name,name))return 1;
           tmp_label=tmp_label->prev;
 					}
return 0; }


void add_offset_access(int type, char mathsym, int addoffset,int size, char *name){ //0=offsetwanted, 1=segmentwanted
/* access_st *tp;
	if(tmp_label==NULL)return;
	tp=(access_st*)malloc(sizeof(access_st));
	if(tp==NULL){ out_of_mem=1; return;}
	malfreecntr++;
	tp->prev=tmp_label->top_access;
	tmp_label->top_access=tp;
	tp->mathsym=mathsym;
        tp->offset=real_code_ptr+addoffset;
	tp->type=type;
        tp->siz=size;*/

 if(type!=1) fprintf(our_outfile,"\n#o%c%d%s\n",mathsym,size,name);
 else fprintf(our_outfile,"\n#s%c%d%s\n",mathsym,size,name);

return; }

void add_label(int siz, int type,unsigned long offset, int seg, char *name){
 lab_st *t;
 tmp_label=(lab_st *)malloc(sizeof(lab_st));
 if(tmp_label==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 if(top_label==NULL){
         tmp_label->prev=top_label; top_label=tmp_label;
         }
 else{ t=top_label;
       while(t->prev) t=t->prev; 
       tmp_label->prev=NULL; t->prev=tmp_label;
                }
 
 tmp_label->offset=offset;

 tmp_label->islocal=0;

 tmp_label->type=type;
 tmp_label->seg=seg;
 tmp_label->siz=siz;
// tmp_label->top_access=NULL;
 
 tmp_label->name=(char *)malloc(strlen(name)+1);
 if(tmp_label->name==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 strcpy(tmp_label->name,name);
return; }


//void addlabeloffsetstore(off_set,islabel,labelset[parmnum],labeltmp[parmnum],size){

void addlabeloffsetstore(unsigned long offset,int type, int mathsym, char *name, int size){ //we store it
 int cn;

 //printf("Offset %lu+MASTEROFFSET ((type=%d) %c %s (BYTES to write %d))\n",offset,type,mathsym,name,size);
 //type==1 [0000]  (offset)
 //type==2  0000   (offset)  write SIZE amount (1,2,4 bytes) for all
 //type==3  0000   (segment)
 //mathsym is what we do to what's there
 //offset is the extra position we add

//printf(">%d (%s)<",type,name);

 //if(type!=3) fprintf(our_outfile,"\n#o%c%d%s\n",mathsym,size,name);
 // else fprintf(our_outfile,"\n#s%c%d%s\n",mathsym,size,name);

 cn=0; if(type==3)cn=1;
 if(find_label(name)==1)add_offset_access(cn,mathsym,0,size,name);//offset);
 else{  add_label(size,-1,0,0,name);
                add_offset_access(cn,mathsym,0,size,name);//offset);
 			}
return; }



void store_label(int type, int siz, char *name){//stores a label: offset
//type 0 = LABEL db etc
//type 1 = Label: (proc near)
//type 2 = Segment
   if(type>0){ siz=2;
               if(out32==1)siz=4;
                }

 if(type!=2) fprintf(our_outfile,"#O%d%s\n",siz,name);
 else fprintf(our_outfile,"#S%d%s\n",siz,name);


   if(find_label(name)==1){ 
                    if(tmp_label!=NULL && tmp_label->type==-1){
                         	             tmp_label->siz=siz;
                         	             tmp_label->type=type;
                         	             tmp_label->seg=currentseg;
                                             if(type==2) tmp_label->offset=real_code_ptr;
                                             else tmp_label->offset=seg_code_ptr;
                    						}
   					else {error("Label already defined",ERROR); return; }
   					}
//   else add_label(siz,type,real_code_ptr,currentseg,name);
else{ if(type==2)add_label(siz,type,real_code_ptr,currentseg,name);
      else add_label(siz,type,seg_code_ptr,currentseg,name);
        }


   //printf("Store %s (Seg %d : Offset %lu)\n",name,currentseg,real_code_ptr);
   if(type==2)currentseg++;
return; }



void store_byte(unsigned char byt){
// printf("(%x)",byt);
/* if(the_code==NULL){
 		the_code=(unsigned char *)malloc(code_step+5);
 		if(the_code==NULL){ out_of_mem=1; return; }
 		malfreecntr++;
 		code_size=code_step;
                code_ptr=0; real_code_ptr=0; seg_code_ptr=0;
 		}
 else if(real_code_ptr+1>=code_size){
                        the_code=(unsigned char *)realloc(the_code,code_size+code_step+5);
                        if(the_code==NULL){ malfreecntr--; out_of_mem=1;
                                           real_code_ptr=code_ptr=code_size=0; return; }
                        code_size+=code_step;
 							}
 the_code[real_code_ptr++]=byt;*/


 fprintf(our_outfile,"%.2X",byt);

 seg_code_ptr++; code_ptr++;
 if(hadoverwarn==0 && out32==0 && seg_code_ptr>64000){
                                        hadoverwarn=1;
                                        error("Segment exceeds 64k",WARNING);
                                                }
return; }

void store_word(unsigned int num){
   store_byte((unsigned char)LOWBYTE(num)); 
   store_byte((unsigned char)HIGHBYTE(num));
return; }

void store_dword(unsigned long num){
 unsigned long numa,numb;
 numa=num/0x10000;
 numb=num-(numa*0x10000);
 store_word((unsigned int)numb);
 store_word((unsigned int)numa);
return; }


void add_label_offset32(char *name){
 if(find_label(name)==1)add_offset_access(0,'+',0,4,name);
 else{  add_label(4,-1,0,0,name);
                add_offset_access(0,'+',0,4,name);
 			}
  //printf("label offset address %s ",name);
  store_dword(0);
return; }

void add_label_offset16(char *name){
 // printf("label offset address %s ",name);
 if(find_label(name)==1) add_offset_access(0,'+',0,2,name);
 else{  add_label(2,-1,0,0,name);
                add_offset_access(0,'+',0,2,name);
 			}
  store_word(0);
return; }

void add_label_seg16(char *name){
 if(find_label(name)==1) add_offset_access(1,'+',0,2,name);
 else{  add_label(2,-1,0,0,name);
                add_offset_access(1,'+',0,2,name);
 			}
  //printf("label seg address %s ",name);
  store_word(0);
return; }



void free_incs(){
inc_stack *tp;
		while(top_inc){
					tp=top_inc->prev;
					if(top_inc->name!=NULL){ free(top_inc->name); malfreecntr--; }
					if(top_inc->hnd!=NULL)fclose(top_inc->hnd);
					free(top_inc); malfreecntr--;
		            top_inc=tp;
						}
return; }			
			

void pop_inc(){
 inc_stack *tp;
 if(top_inc==NULL)return;
 fclose(cur_file);
 cur_file=top_inc->hnd;
 if(top_inc->name!=NULL){ free(top_inc->name); malfreecntr--; }
 tp=top_inc->prev;
 linecntr=top_inc->linecntr;
 free(top_inc); malfreecntr--;
 top_inc=tp;
return; }


void push_curfile(FILE *hnd, char *name){
 inc_stack *tp;
 tp=(inc_stack *)malloc(sizeof(inc_stack));
 if(tp==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 tp->prev=top_inc; top_inc=tp;

 tp->linecntr=linecntr;
 linecntr=0;
 tp->hnd=cur_file;
 cur_file=hnd;
 
 tp->name=(char *)malloc(strlen(name)+1);
 if(tp->name==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 strcpy(tp->name,name);
 
return; }

typedef struct marcolines{
                char *line;
                struct marcolines *prev;
                }marcolines;
marcolines *tmpname=NULL;

void copyto_tmpname(char *str){
  marcolines *tp;
  tp=( marcolines *)malloc(sizeof( marcolines ));
  if(tp==NULL){ out_of_mem=1; return; }
  malfreecntr++;
  tp->prev=tmpname; tmpname=tp;
  tp->line=(char *)malloc(strlen(str)+1);
  if(tp->line==NULL){ out_of_mem=1; return; }
  malfreecntr++;
  strcpy(tp->line,str);
return; }

int tmpname_parmcnt=0;
void free_tmpname(){
 marcolines *tp;
 while(tmpname){
 		tp=tmpname->prev;
 		if(tmpname->line!=NULL){ free(tmpname->line); malfreecntr--; }
 		free(tmpname); malfreecntr--;
 		tmpname=tp;
 		}
 tmpname_parmcnt=0;
return; }

int check_tmpwords(char *theword){
 marcolines *tp=tmpname;
 int a=0;
 if(tmpname_parmcnt==0)return -1;
 while(tp){
		if(!stricmp(tp->line,theword)) return a;
 		tp=tp->prev; a++;
 		}
return -1; }


void findmarconame(char num){
 marcolines *tp=tmpname;
 char cnt=0;
 theword[0]=0;
 while(tp){
        if(cnt==num){ strcpy(theword,tp->line); break; }
        cnt++;
 		tp=tp->prev;
 		}
return; }

typedef struct marcohold{
                char *name;
                int parmcnt;
                marcolines *topline;
                struct marcohold *prev;
                }marcohold;
marcohold *top_marco=NULL;

void free_marco_lines(marcolines *top){
 marcolines *tmp;
 while(top){
         tmp=top->prev;
         
         //printf("%s,",top->line);
         
         if(top->line!=NULL){ free(top->line); malfreecntr--; }
         free(top);malfreecntr--; 
 		 top=tmp;
 		 }
return; }

void free_marcos(){
 marcohold *tmp;
 while(top_marco){
 	  tmp=top_marco->prev;
 	  
 	  //printf("marco %s:",top_marco->name);
 	  
 	  if(top_marco->topline!=NULL) free_marco_lines(top_marco->topline);
 	  if(top_marco->name!=NULL){ free(top_marco->name); malfreecntr--; }
 	  free(top_marco); malfreecntr--;
 	  top_marco=tmp;
 	  }
return; }

marcohold *tmpmarco_ptr;
int findmarco(char *name){
 tmpmarco_ptr=top_marco;
 while(tmpmarco_ptr){ 	  
 	   if(!stricmp(tmpmarco_ptr->name,name))return 1;
 	   
 	   tmpmarco_ptr=tmpmarco_ptr->prev;
 	  }
return 0; }

marcohold *makemarco(char *name){
 marcohold *tmp;
 tmp=(marcohold *)malloc(sizeof( marcohold ));
 if(tmp==NULL){ out_of_mem=1; return NULL; }
 else malfreecntr++;
 
 tmp->prev=top_marco; top_marco=tmp;
 tmp->topline=NULL;
 tmp->parmcnt=0;
 tmp->name=(char *)malloc(strlen(name)+1);
 if(tmp->name==NULL)out_of_mem=1;
 else { malfreecntr++;
 		 strcpy(tmp->name,name);
 		 }
return tmp; }


void store_marco_line(marcohold *tp,char *line){
  marcolines *laline;
  if(tp==NULL || line==NULL || line[0]==0)return;//no need
  
  laline=(marcolines *)malloc(sizeof(marcolines));
  if(laline==NULL){ out_of_mem=1; return; }
  else malfreecntr++;
  
  if(tp->topline!=NULL){
  		laline->prev=tp->topline->prev;
  		tp->topline->prev=laline;  
  			}
  else{
		laline->prev=NULL;
  		tp->topline=laline;
  			}			
  
  laline->line=(char *)malloc(strlen(line)+1);
  if(laline->line==NULL){ out_of_mem=1; return; }
  malfreecntr++;
  
  strcpy(laline->line,line);

return; }


typedef struct filehold{
                char *name;
                struct filehold *prev;
                }filehold;
filehold *top_filecomp=NULL;

int storefiletocompile(char *name){
  filehold *tmpf;
  int cn;
  char k;

  tmpf=(filehold *)malloc(sizeof(filehold));
  if(tmpf==NULL){ out_of_mem=1; return 1; }
  malfreecntr++;

  tmpf->prev=top_filecomp; top_filecomp=tmpf;
  
  
  k=4;
  for(cn=strlen(name); cn>0; cn--)
				  if(name[cn]=='.'){ k=0; break; }
  tmpf->name=(char *)malloc(strlen(name)+1+k);
  if(tmpf->name==NULL){ out_of_mem=1; return 1; }
  malfreecntr++;  
  strcpy(tmpf->name,name);
  if(k>0)strcat(tmpf->name,".asm");
return 0; }

void free_storedfilenames(){
  filehold *tmpf;
  while(top_filecomp){
            tmpf=top_filecomp->prev;
            if(top_filecomp->name){ free(top_filecomp->name);
                                    malfreecntr--; }
            free(top_filecomp);
           malfreecntr--;
            top_filecomp=tmpf;
                }
return; }


int isletnum(char k){
  int t;
  t=toupper(k);
  if(t>='A' && t<='Z')return 1;
  else if(t>='0' && t<='9')return 1;
  else if(t=='_' || t=='@')return 1;
return 0; }


void convertnum(int range){
  unsigned long thenum=0;
  int cnt=0;
  char k;
  
  for(;;){
  	k=toupper(theword[cnt]);
  	if(k==0)break;    
    if(k=='H' || k=='O' || (range==2 && k=='B'))break;
    thenum*=range;
    if(k>='A') { k-='A'; k+=10; }
    else k-='0';
    if(k>=range){ error("Invalid Number",ERROR); break; }
    thenum+=k;
    cnt++;
        }
 sprintf(theword,"%lu",thenum);
return; }

int read_line(int inmarco){
	int k,op,in_str1=0,in_str2=0,ignore=0,a;
	int ret=0,f_th=0;
	char tmpw[5];
    lptr=0;
    for(;;){
    	k=fgetc(cur_file);
    	if(ignore==0 && in_str1==0 && in_str2==0 && isletnum(k)==1){
    			op=0; theword[0]=0;    			
    			for(;;){
    			       theword[op++]=k;
    			       k=fgetc(cur_file);
    			       if(isletnum((char)k)==0)break;
    								}
    			 theword[op]=0;
    			 curline[lptr]=0;
				 dofind_equ(theword);
				 if(inmarco==1){
				 	a=check_tmpwords(theword);
				 	if(a>-1)sprintf(theword,"%%%d",a);				 
				 	
				 	if(findillegaldirective(f_th,theword)==1){ error("Cannot have this Directive inside a Marco",ERROR);
				 											break; }
				 	
				 	if(findmarco(theword)==1){ error("Cannot have a Marco inside a Marco",ERROR);
				 							   break; }
				 	
				 
				 	if(!stricmp(theword,"ENDMARCO"))ret=1;
				 			}
				 if(isdigit(theword[0])){//hex/bin/octal to decimal				 
				                       if(toupper(theword[strlen(theword)-1])=='H') convertnum(16);
				                       else if(toupper(theword[strlen(theword)-1])=='B')convertnum(2);
				                       else if(toupper(theword[strlen(theword)-1])=='O')convertnum(8);
				 						}
				 strcat(curline,theword);
				 lptr=strlen(curline);
				 f_th++;
    					}
    	if(k=='\"')in_str1=1-in_str1;
                //changed in_str2 to in_str1 below
            if(in_str1==0 && ignore==0 && k=='\''){//in_str2=1-in_str2;
	              k=fgetc(cur_file);
	    		  for(;;){
	               		sprintf(tmpw,"%d",k); curline[lptr]=0;
	               		strcat(curline,tmpw); lptr=strlen(curline);
	               		k=fgetc(cur_file);
	               		if(k=='\n' || k<1)break;
	               		if(k=='\''){  k=fgetc(cur_file);
	               					  break;  }
	               		}
	       			}
    	if(k<1){ endof=1; break; }
		if(k=='\n')break;
    	if(k==9)k=32;
		if(in_str1==0 && in_str2==0 && k==';')ignore=1;//lose the rest
    	if(ignore==0)curline[lptr++]=k;
    	if(lptr>255)lptr=255;
    		}
    linecntr++; total_linecntr++;
    curline[lptr]=0; if(lptr>254) error("Line too long",WARNING);
	lptr=0;

// printf(">%d%s<\n",inmarco,curline);
return ret; }

void skipspaces(){
 char k;
 for(;;){
 	k=curline[lptr];
 	if(k!=32)break;
 	lptr++;
      }
return; }

//get everything till , or ) or eol
void getnextall(){
 int lap=0;
 char k;
 int instr1=0,instr2=0;
 theword[0]=0;
 skipspaces();
 for(;;){    
  	k=toupper(curline[lptr]);

	if(k==0)break;
	if(k=='\'')instr1=1-instr1;
	if(k=='\"')instr2=1-instr2;
	if(instr1==0 && instr2==0)if(k==',' || k==')')break;
  	theword[lap++]=k;  	
	lptr++;
         }
 theword[lap]=0;        
return; }


typedef struct equtables{
                char *line;
                char *name;
                struct equtables *prev;
                }equtables;
equtables *top_equtable=NULL;

void free_equs(){
 equtables *tp;
 while(top_equtable){
              tp=top_equtable->prev;
              if(top_equtable->line!=NULL){ free(top_equtable->line); malfreecntr--; }
              if(top_equtable->name!=NULL){ free(top_equtable->name); malfreecntr--; }              
              free(top_equtable); malfreecntr--; 
              top_equtable=tp;
 				}
return; }


int dofind_equ(char *name){
  equtables *tp=top_equtable;
  while(tp){
     if(!stricmp(tp->name,name)){ strcpy(theword,tp->line); return 1; }
  	tp=tp->prev;
  			}

return 0; }

void doequ(char *name){
 int ln;
 equtables *tp;
 
 ln=strlen(curline)-lptr;
 
 tp=(equtables *)malloc(sizeof(equtables));
 if(tp==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 
 tp->prev=top_equtable; top_equtable=tp;
 tp->name=NULL;
 tp->line=(char *)malloc(ln+2);
 if(tp->line==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 strcpy(tp->line,curline+lptr);
 
 tp->name=(char *)malloc(strlen(name)+1);
 if(tp->name==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 strcpy(tp->name,name);

return; }

void getnextword(){
 int lap=0;
 char k;
 theword[0]=0;
 skipspaces();
 for(;;){    
        if(case_sensi)k=curline[lptr];
        else k=toupper(curline[lptr]);
  	
  	if(isletnum(k)==1)theword[lap++]=k;
  	else break;
	lptr++;
         }
 theword[lap]=0;        
return; }


unsigned long getdanum(char sz){//1=byte, 2=word, else dword, report oversize
 unsigned long num,total_num=0;
 unsigned char ourl_c;
 unsigned short ourl_i;
 char k,mathsym=0,gotsome,endme=0,isminus;
 for(;;){
   skipspaces(); num=0; gotsome=0; k='0'; isminus=0;
   for(;;){
        num*=10;  num+=k-'0';
        k=curline[lptr];
        if(k=='-'){ isminus=1; lptr++; k=curline[lptr]; }
        if(k==32 || k==0){      if(isminus){error("Number required",ERROR);
                                            endme=1; }
                                break; }
        if(k<'0' || k>'9'){ if(gotsome==0){error("Number required",ERROR);
                                                      endme=1; }
        					break; }
        gotsome=1; lptr++;
              }
     if(isminus)num=-num;
     switch(mathsym){
                    case 0: total_num = num; break;
                    case '+': total_num += num; break;
                    case '-': total_num -= num; break;
                    case '*': total_num *= num; break;
                    case '/': if(num!=0)total_num /= num; break;
                    case '^': total_num ^= num; break;
                    case '%': if(num!=0)total_num %= num; break;
                    case '|': total_num |= num; break;
                    case '&': total_num &= num; break;
                        }

     if(endme)break;
     skipspaces();
     k=curline[lptr];

     if(k=='+' || k=='-' || k=='*' || k=='/' ||
        k=='^' || k=='%' || k=='|' || k=='&'){ mathsym=k; lptr++; }
     else break;
         }
 switch(sz){
        case 1:  ourl_c=total_num; total_num=ourl_c;
                 if(total_num>0xff)error("Number out of range",WARNING);
                 break;
        case 2:  ourl_i=total_num; total_num=ourl_i;
                 if(total_num>0xffff)error("Number out of range",WARNING);
                 break;
          }
return total_num; }

void unpackmac(){
  marcolines *tp;
  int itp,instr1,instr2;
  char parnum;
  char k;
 
  if(tmpmarco_ptr==NULL || tmpmarco_ptr->topline==NULL)return;  
  tp=tmpmarco_ptr->topline;
  while(tp){
        lptr=itp=instr1=instr2=0;
        for(;;){
              k=tp->line[itp++];
              if(k==0)break;
              if(k=='\'')instr1=1-instr1;
              if(k=='\"')instr2=1-instr2;  
              if(instr1==0 && instr2==0 && k=='%'){//unpack the mac
             				parnum=tp->line[itp++]-'0';
             				curline[lptr]=0;
             				findmarconame(parnum);
             				strcat(curline,theword);
             				lptr=strlen(curline);
              						}
              else curline[lptr++]=k;
         		}
		curline[lptr]=0;
		if(assemble(curline)==-1)break;
  		tp=tp->prev; 
  		}
return; }


void unpackmarco(){
  int doneit=0,parmcnt;
  marcolines *tp;

  if(tmpmarco_ptr==NULL)return;
  skipspaces();
  if(curline[lptr]=='('){ 
  				lptr++; skipspaces();
  				if(curline[lptr]==')') lptr++;
  				else{ doneit=1;
  					  if(tmpmarco_ptr->parmcnt==0){ error("Marco has too many parameters",ERROR); return; }
  				      free_tmpname(); parmcnt=0;
  				      	//loop to get parameters
 						for(;;){
 						     parmcnt++;
 						     //get everything till , or ) or eol
 						     getnextall();
 							 copyto_tmpname(theword);
 							 if(out_of_mem==1)break; 
 							 skipspaces();
 							 if(curline[lptr]==',')lptr++;
 							 else if(curline[lptr]==')'){lptr++; break; }
 							 else { error("Missing ,",ERROR); break; }
 								}//for 						   
 						 //unpack each line....  
 						 if(parmcnt>tmpmarco_ptr->parmcnt)error("Too many Parameters in Marco call",ERROR);
 						 else if(parmcnt<tmpmarco_ptr->parmcnt)error("Missing Parameter in Marco call",ERROR);
 						 else unpackmac();
 						   }//else we have a parameter
  						}
  if(doneit==0){//easy one (parameterless)
  	if(tmpmarco_ptr->parmcnt!=0){ error("Marco is missing parameter",ERROR); return; }
  	tp=tmpmarco_ptr->topline;
  	while(tp){  	
  	        if(tp->line!=NULL && tp->line[0]!=0) if(assemble(tp->line)==-1)break;
  	        tp=tp->prev;
  					}
  
				}
return; }
         

int finddirective(char *name){
 int cnt=0;
 for(;;){
    if(directives[cnt]==NULL)break;
    if(!stricmp(directives[cnt],name))return cnt;
    cnt++;
 			}
return -1; }

int findasmcom(char *name){
  int cnt=0;
  for(;;){
    if(opcodes[cnt].name==NULL)break;
    if(!stricmp(opcodes[cnt].name,name))return 1;
    cnt++;
  		}
return 0; }


void testendofline(){
  skipspaces();
  if(curline[lptr]!=0)error("Rest of line will be Ignored",WARNING);
return; }


int scanoff_seg(){//ret 1 offset, 2 = seg
 
 skipspaces();
 if(toupper(curline[lptr])=='O' &&
 	toupper(curline[lptr+1])=='F' &&
 	toupper(curline[lptr+2])=='F' &&
 	toupper(curline[lptr+3])=='S' &&
 	toupper(curline[lptr+4])=='E' &&
 	toupper(curline[lptr+5])=='T' &&
 	toupper(curline[lptr+6])==' '){ lptr+=6; return 1; }

 if(toupper(curline[lptr])=='S' &&
 	toupper(curline[lptr+1])=='E' &&
 	toupper(curline[lptr+2])=='G' &&
        toupper(curline[lptr+3])==' '){ lptr+=3; return 2; }

return 0; }

void loop_andstore(int wh){
	char k;
	int a;
	unsigned long num,num2;
    skipspaces();
    if(curline[lptr]=='?'){ lptr++; 
                             testendofline();
    						 return; }
	switch(wh){
			case 1:
					if(scanoff_seg()!=0)error("Address is not BYTE size",ERROR);
					else for(;;){
								skipspaces();
								k=curline[lptr];
								if(k==0)break;
                                                                else if((k>='0' && k<='9') || k=='-'){//get number
                                                                                    num=getdanum(1);
                                                                                    //if(num>0xFF)error("Number out of range of storage type",WARNING);
								                    store_byte((unsigned char)num);
														}
								else if(k=='\"'){ lptr++;
											for(;;){
											    k=curline[lptr++];
											    if(k=='\"')break;
											    store_byte(k);
                                                                                                       }
                                                                                           }
								else if(k==','){ lptr++;
                                                                                          store_byte(0);
												}
                                                                else { error("Data error",ERROR); break; }
								skipspaces();
								k=curline[lptr];                                                                
								if(k==0)break;
								else if(k==',') lptr++;
                                                                else {  //printf(">%c %d %s\n",k,lptr,curline);
                                                                        error("Data error",ERROR); break; }
								if(out_of_mem==1)break;
								   }
             fprintf(our_outfile,"\n");
             break;
            case 2:
            		for(;;){
            			skipspaces();
            			a=scanoff_seg();
                                if(a!=0 && out32==1)error("Address is DWORD size in 32bit out",WARNING);
            			if(a==1){//offset
            			         getnextword();
                                         fprintf(our_outfile,"\n");
            			         add_label_offset16(theword);
            							}
            			else if(a==2){//segment
                                         if(out32==1)error("32bit shouldn't have Segments",WARNING);
            			         getnextword();
                                         fprintf(our_outfile,"\n");
            			         add_label_seg16(theword);
                                                          }
            			else{//number
            					if(curline[lptr]=='\"'){ error("Can only store strings with DB",ERROR);
            											 break; }
                                                                num=getdanum(2);
                                                                //if(num>0xFFFF)error("Number out of range of storage type",WARNING);
								store_word((unsigned int)num);
									}
						skipspaces();
						if(curline[lptr]==',')lptr++;
						else if(curline[lptr]==0)break;
                                                else { error("Data error",ERROR); break; }
						if(out_of_mem==1)break;
                         }//the for
                        fprintf(our_outfile,"\n");
                        break;
            case 3:
            		for(;;){
            			skipspaces();
            			a=scanoff_seg();
                                if(a!=0 && out32!=1)error("Address is WORD size in 16bit out",WARNING);
            			if(a==1){//offset
            			         getnextword();
                                         fprintf(our_outfile,"\n");
            			         add_label_offset32(theword);
            							}
            			else if(a==2){//segment
                                         error("Out 32bit doesn't support seg",ERROR);
                                                       break;
            			        			}
            			else{//number
            					if(curline[lptr]=='\"'){ error("Can only store strings with DB",ERROR);
            											 break; }
                                                                num=getdanum(3);
								store_dword(num);
									}
						skipspaces();
						if(curline[lptr]==',')lptr++;
						else if(curline[lptr]==0)break;
                                                else { error("Data error",ERROR); break; }
						if(out_of_mem==1)break;
                         }//the for
                    fprintf(our_outfile,"\n");
                    break;
            default:
                num=getdanum(wh-3);
            	skipspaces();
                if(curline[lptr]==','){lptr++; num2=getdanum(wh-3);
            	                         for(;num>0; num--){
            	                                           if(wh==4)store_byte((unsigned char)num2);
            	                                           if(wh==5)store_word((unsigned int)num2);
            	                                           if(wh==6)store_dword(num2);
                                                             }
                                        fprintf(our_outfile,"\n");
                                             }
            	else if(curline[lptr]==0){
            	                         for(;num>0; num--){
            	                                           if(wh==4)store_byte(0);
            	                                           if(wh==5)store_word(0);
                                                           if(wh==6)store_dword(0);
                                                               }
                                          fprintf(our_outfile,"\n");
                                           }
                else error("Data error",ERROR);
					}
return; }

void make_16even(){//so segments are always at a paragraph
 while(1){
         if(real_code_ptr%16==0)break;
         store_byte(0);
                }
return; }


int do_label_thing(){
  char label[255];
  
    strcpy(label,theword);
	if(curline[lptr]==':'){ lptr++;
                                store_label(1,0,label);
                                skipspaces();
                                if(curline[lptr]!=0)return 1;
                                    }
	else{
		skipspaces();
		getnextword();

                if(!stricmp(theword,"PROC")){
 			 skipspaces();
 			 if(toupper(curline[lptr])=='F' &&
 			 	 toupper(curline[lptr+1])=='A' &&
 			 	  toupper(curline[lptr+2])=='R' &&
                                   (curline[lptr+3]==0 || toupper(curline[lptr+3])==' ')){ lptr+=3;
                                                        if(mem_model==1)error("Current Memory Model shouldn't have Segments",WARNING);
                                                        if(out32==0)make_16even();
                                                        store_label(2,0,label);
                                                        seg_code_ptr=0; code_ptr=0;
                                                        hadoverwarn=0;
                                                        testendofline();
                                                                 }
                         else{ if(toupper(curline[lptr])=='N' &&
 			 	 	toupper(curline[lptr+1])=='E' &&
 			 	  	toupper(curline[lptr+2])=='A' &&
 			 	   	toupper(curline[lptr+3])=='R' &&
                                        (curline[lptr+4]==0 || curline[lptr+4]==' ')) lptr+=4;
                                    store_label(1,0,label);
                                    testendofline();
                                         }
                            }
                else if(!stricmp(theword,"SEG")){
                        if(mem_model==1)error("Current Memory Model shouldn't have Segments",WARNING);
                        if(out32==0)make_16even();                        
                        store_label(2,0,label);
                        testendofline(); 
                        seg_code_ptr=0; code_ptr=0;
                        hadoverwarn=0;
                                 }
                else if(!stricmp(theword,"EQU")){ skipspaces(); doequ(label); }
		else if(!stricmp(theword,"DB")){ store_label(0,1,label);
                                                 loop_andstore(1);//this can be offset/segment (16,32bit)
                                                           }
		else if(!stricmp(theword,"DW")){ store_label(0,2,label);
										 loop_andstore(2);//this can be offset/segment (16,32bit)
										 }
		else if(!stricmp(theword,"DD")){ store_label(0,4,label);
										 loop_andstore(3);//this can be offset/segment (16,32bit)
										 }
		else if(!stricmp(theword,"DUB_DB")){
									     store_label(0,1,label);
										 loop_andstore(4);//this can be offset/segment (16,32bit)
										 }
		else if(!stricmp(theword,"DUB_DW")){
										 store_label(0,2,label);
										 loop_andstore(5);//this can be offset/segment (16,32bit)
										 }
		else if(!stricmp(theword,"DUB_DD")){
										 store_label(0,4,label);
										 loop_andstore(6);//this can be offset/segment (16,32bit)
										 }
                else error("Unknown Command or Directive",ERROR);
	    	}
return 0; }

void do_include(){
  int ct;
  char k;
  FILE *hnd;
  
  skipspaces();
  if(curline[lptr]!='\"'){ error("Missing filename",ERROR); return; }
  lptr++;
  ct=0;
  for(;;){
  		k=curline[lptr];
  		if(k==0 || k==','){ error("Missing \"",ERROR); return; }
  		if(k==32 || k=='\"')break;
        theword[ct++]=k;
        lptr++;
        }
  theword[ct]=0;
  skipspaces();
  if(curline[lptr]!='\"'){ error("Missing \"",ERROR); return; }

  
  hnd=fopen(theword,"r");
  if(hnd==NULL){ error("Cannot open include file",ERROR); return; }
  push_curfile(hnd,theword);

return; }


void do_inlink(){
  FILE *hnd;
  unsigned long st=0, ed=0,cc;
  int ct;
  char k;
  
  skipspaces();
  if(curline[lptr]!='\"'){ error("Missing filename",ERROR); return; }
  lptr++;
  ct=0;
  for(;;){
  		k=curline[lptr];
  		if(k==0 || k==','){ error("Missing \"",ERROR); return; }
  		if(k==32 || k=='\"')break;
        theword[ct++]=k;
        lptr++;
        }
  theword[ct]=0;
  skipspaces();
  if(curline[lptr]!='\"'){ error("Missing \"",ERROR); return; }
  lptr++;
  skipspaces();
  if(curline[lptr]==','){lptr++;
                                                 st=getdanum(4);
  						 skipspaces();
  						 if(curline[lptr]==','){
  						 		 lptr++;
                                                                 ed=getdanum(4);
	  							 skipspaces();
	  							 testendofline();
  						 				}
  						 else if(curline[lptr]!=0){ error("Syntax error",ERROR); return; }
  								}
  else if(curline[lptr]!=0){ error("Syntax error",ERROR); return; }
  
 hnd=fopen(theword,"rb");
 if(hnd==NULL){ error("Cannot open file to inlink",ERROR); return; }
 for(cc=0; cc<st; cc++) fgetc(hnd);//skip start
 if(ed==0){ for(;;){
        		ct=fgetc(hnd);
        		if(ct==-1)break;
        		store_byte((unsigned char)ct);
 							} 
 				}
 else for(cc=0; cc<ed; cc++){
 					ct=fgetc(hnd);
 					if(ct==-1)ct=0;
 					store_byte((unsigned char)ct);
 						}
 fclose(hnd);
return; }



void do_directive(){
 marcohold *our_marco;
 int parmcnt;
 char str_t[100];
//if(finddirective(theword)==1)do_directive();//lets check if it's a directive again (incase no .)
 switch(finddirective(theword)){
 		case 0://Marco
 		    getnextword();
 		    if(findmarco(theword)==1){ error("Marco name already defined",ERROR); break; }
 		    our_marco=makemarco(theword);
 			if(out_of_mem==1)break;
 			skipspaces();
 			parmcnt=0;
 			tmpname_parmcnt=0;
 			if(curline[lptr]=='('){ lptr++;//parameter type (NOTE: stored backwards)
 					    skipspaces();
 					    if(curline[lptr]==')'){lptr++; break; }
 					    free_tmpname();
 						for(;;){
 						     parmcnt++;
 						     if(parmcnt>8){error("Too many Parameters in Marco Defination",ERROR);
 						     				break; }
 							 getnextword();
 							 if(isletnum(theword[0])==0){ error("Marco Parameter must be a label",ERROR); 
 							 							 break; }
 							 copyto_tmpname(theword);
 							 if(out_of_mem==1)break; 
 							 skipspaces();
 							 if(curline[lptr]==',')lptr++;
 							 else if(curline[lptr]==')'){lptr++; break; }
 							 else { error("Missing ,",ERROR); break; }
 								}//for
 							}//if bracket type
 				our_marco->parmcnt=parmcnt;
 				tmpname_parmcnt=parmcnt;
 				for(;;){
			      	if(read_line(1)==1)break;
			      	if(endof==1){ error("Missing Endmarco",ERROR); break; }
				 	store_marco_line(our_marco,curline);
 					if(out_of_mem==1)break;
 					}
 			break;
 		case 1://endmarco
 			error("EndMarco Without Marco",ERROR);
 			break;
 		case 2://equ
 			 error("Equ without label",ERROR);
 			 break;
 		case 3://proc
 			 skipspaces();
 			 if(toupper(curline[lptr])=='F' &&
 			 	 toupper(curline[lptr+1])=='A' &&
 			 	  toupper(curline[lptr+2])=='R' &&
 			 	   toupper(curline[lptr+3])==' '){ lptr+=3;
                                                        if(mem_model==1)error("Current Memory Model shouldn't have Segments",WARNING);
                                                        if(out32==0)make_16even();
                                                        getnextword();
				 	 	 	if(theword[0]==0)error("Missing label",ERROR);
	 	 					else store_label(2,0,theword);
                                                        seg_code_ptr=0;
                                                        code_ptr=0;
                                                        hadoverwarn=0;
                                                        testendofline();
 			 	         			 	  }
 			 else{
 			 	if(toupper(curline[lptr])=='N' &&
 			 	 	toupper(curline[lptr+1])=='E' &&
 			 	  	toupper(curline[lptr+2])=='A' &&
 			 	   	toupper(curline[lptr+3])=='R' &&
 			 	     	curline[lptr+4]==' ') lptr+=4; 			 	     	
 			 	 getnextword();
 			 	 if(theword[0]==0)error("Missing label",ERROR);
 			 	 else { store_label(1,0,theword);
 			 	 		testendofline(); }
 			 	 }
 			 break;
 		case 4://seg
                        if(mem_model==1)error("Current Memory Model shouldn't have Segments",WARNING);
                        if(out32==0)make_16even();
 			getnextword();
 	 	 	if(theword[0]==0)error("Missing label",ERROR);
	 	 	else { store_label(2,0,theword);
	 	 		   testendofline(); }
                        seg_code_ptr=0; code_ptr=0;
                        hadoverwarn=0;
 			 break;
 		case 5://start
                                fprintf(our_outfile,"#dS\n");
				start_seg=currentseg;
				start_offset=code_ptr;
                                //org_offset=code_ptr;
                                if(curline[lptr]==':'){
                                                store_label(1,0,theword);
                                                lptr++;
                                                        }
				testendofline();
 			 break;
 		case 6://setmax
                         set_mem_max=getdanum(2+make32);
 			 testendofline();
 			 break;
 		case 7://org
                     //code_ptr=getdanum(2);
                     org_offset=getdanum(2+make32);
                     testendofline();
 			 break;
 		case 8://stack
                     stack_size=getdanum(2+make32);
 		     testendofline();
 			 break;
	    case 9://inlink
			 do_inlink();
	    	 break;
	    case 10://include
			 do_include();
	    	 break;	
	    case 11://db
				loop_andstore(1);
	    	 break;
	    case 12://dw
				loop_andstore(2);
	    	 break;
	    case 13://dd
				loop_andstore(3);
	    	 break;	 
		case 14://dub_db
			    loop_andstore(4);
			 break;
		case 15://dub_dw
				loop_andstore(5);
			 break;
		case 16://dub_dd
				loop_andstore(6);
			 break;
                case 17://stackseg
                         if(mem_model==1)error("Current Memory Model or format doesnt support Segments",ERROR);
                         stack_seg=currentseg;//getdanum();
                         testendofline();
                         fprintf(our_outfile,"#dt\n");
                         break;
                case 18://extern
		    getnextword();
		    if(find_label(theword)==1){ 
                    if(tmp_label!=NULL && tmp_label->type==-1){
                         	             //tmp_label->siz=siz;
                         	             tmp_label->type=3;
                         	             //tmp_label->seg=currentseg;
                         	             //tmp_label->offset=code_ptr;
                    						}
                                        else {  sprintf(str_t,"Label \"%s\" already defined",theword);
                                                error(str_t,ERROR); return; }
   								}
                   else add_label(0,3,0,0,theword);
                   testendofline();
                   break;
                case 19://local
                  for(;;){
                   getnextword();
                   if(find_label(theword)!=1){
                                         sprintf(str_t,"label \"%s\" not found",theword);
                                         error(str_t,ERROR);
                                                }
                   if(tmp_label)tmp_label->islocal=1;
                   skipspaces();
                   if(curline[lptr]==0)break;
                   if(curline[lptr]!=','){ error("Missing ,",ERROR); break; }
                   lptr++;
                          }
                   break;
                case 20://use32
                        out32=1; testendofline(); break;
                case 21://use16
                        out32=0; testendofline(); break;
                case 22://out32
                        make32=1; testendofline(); break;
                case 23://model
                       getnextword();
                       if(!stricmp(theword,"TINY"))mem_model=1;
                       else if(!stricmp(theword,"NOTTINY"))mem_model=2;
                       else { sprintf(str_t,"Illegal memory model %s",theword);
                              error(str_t,ERROR); break; }
                       testendofline();
                   break;
                case 24://outcom
                        mem_model=1; out_type=1;
                       testendofline();
                   break;
                case 25://outlib
                       out_type=2;//LIB file
                       testendofline();
                   break;
                case 26://casesensi
                       case_sensi=1;
                       testendofline();
                   break;
                case 27://"ASSUMEDSCS"
                        lose_nodata_error=1;
                        testendofline();
                   break;
	default:
			error("Invalid directive",ERROR);
			}
return; }

/*
void dump_variable_table(FILE *hnd){
 access_st *acc_tp;
 lab_st *tp=top_label;
 
 if(hnd==NULL || top_label==NULL)return;
 
 while(tp){ 
 			fputc('n',hnd);//write label name id
 			fprintf(hnd,"%s%c",tp->name,0);//name
 			fputc(tp->type,hnd);//type
                        fputc(tp->siz+'0',hnd);//siz
                        fputc(tp->islocal+'0',hnd);//islocal..NEW
                        fprintf(hnd,"%.4x",tp->seg);//seg its in!!!
 			fprintf(hnd,"%.8lx",(unsigned long)tp->offset);//offset
 			acc_tp=tp->top_access; //accesses
            while(acc_tp){
                        fputc('a',hnd);//write another access id
                        fputc(acc_tp->mathsym,hnd);
                        fputc(acc_tp->type+'0',hnd);
                        fputc(acc_tp->siz+'0',hnd);
                        fprintf(hnd,"%.8lx",(unsigned long)acc_tp->offset);//write access offset
                        acc_tp=acc_tp->prev;
            			}
 			tp=tp->prev;
 				}
return; }

void dump_sob(char *fname){
 int k=4;
 int cn;
 unsigned long p;
 FILE *hnd;
 char *oname=NULL;
 table_relative *tp;
  
  for(cn=strlen(fname); cn>0; cn--)
				  if(fname[cn]=='.'){ k=0; break; }				  
  oname=(char *)malloc(strlen(fname)+5+k);
  if(oname==NULL){ out_of_mem=1; return; }
  malfreecntr++;  
  strcpy(oname,fname);
  if(k>0)strcat(oname,".sob");
  else { oname[cn+1]='s'; oname[cn+2]='o'; oname[cn+3]='b'; oname[cn+4]=0; }

  //printf("Out %s\n",oname);
  hnd=fopen(oname,"wb");
  if(hnd!=NULL){
              fprintf(hnd,"%c%c",0x19,0x76);//sob id
              fprintf(hnd,"%c",1);//sob version number
              fprintf(hnd,"Snakessoft Linker Object File%c",0);//text string
              fprintf(hnd,"%c%c",SASM_ID_,SASM_vernum_);//made with sasm id,version
              cn=1;
      		  if(out_type==1)cn=2;
      		  else if(out_type==2)cn=3;
      		  else if(mem_model==1)cn=0;
   			  fprintf(hnd,"%c",cn);//0=tiny, 1=normal, 2=com ,3=lib
                          fprintf(hnd,"%c",make32);//32bit output
                      fprintf(hnd,"%.8lx",(unsigned long)start_seg);
                      fprintf(hnd,"%.8lx",(unsigned long)start_offset);

                      fprintf(hnd,"%.8lx",(unsigned long)stack_size);
                      fprintf(hnd,"%.8lx",(unsigned long)stack_seg);

                      fprintf(hnd,"%.8lx",(unsigned long)set_mem_max);

   			  //relative table
   			  tp=top_relat;
                           while(tp){
				   fputc('r',hnd);
				   fputc(tp->size,hnd);
				   fprintf(hnd,"%.8lx",tp->offset);
	               tp=tp->prev;
					}
					
              //variable table
              dump_variable_table(hnd);
              fputc('p',hnd);//program comes id
              fprintf(hnd,"%.8lx",(unsigned long)real_code_ptr);//prgram length
              //program...
              for(p=0; p<real_code_ptr; p++) fputc(the_code[p],hnd);
              fclose(hnd);
  						}
  else error("Cannot create .SOB file",ERROR); 
  if(oname!=NULL){ free(oname); malfreecntr--; }
return; }
  */


int open_outfile(char *fname){
 int cn;
 char *oname=NULL;

  oname=(char *)malloc(strlen(fname)+5);
  if(oname==NULL){ out_of_mem=1; return 0; }
  malfreecntr++;  

  strcpy(oname,fname);
  for(cn=strlen(oname); cn>0; cn--)
                        if(oname[cn]=='.'){ oname[cn]=0; break; }
  strcat(oname,".sob");

  if(our_outfile!=NULL)fclose(our_outfile);
  our_outfile=fopen(oname,"wb");
  if(our_outfile==NULL){ error_cnt++;
                         sprintf(pr_str,"Cannot open %s\n",oname);
                         print_f(pr_str);
                         total_err++;
                        free(oname);malfreecntr--;
                        return 0; }
  free(oname);malfreecntr--;

  fprintf(our_outfile,"%c%c\n",0x19,0x76);//sob id
  fprintf(our_outfile,"##\n## Snakessoft Linker Object File\n");//text string
  fprintf(our_outfile,"##\n## SASM %s Generated file\n##\n",SASM_ver_);
return 1; }


void dump_directives(){
//first we dump externs
 tmp_label=top_label;
 while(tmp_label){
//could be update'd to use extern seg...But no need
           if(tmp_label->type==3)fprintf(our_outfile,"#E%s\n",tmp_label->name);
           tmp_label=tmp_label->prev;
                         }

 if(lose_nodata_error) fprintf(our_outfile,"#dd\n");
 if(org_offset)fprintf(our_outfile,"#dr%.8lx\n",org_offset);
 fprintf(our_outfile,"#dT%d\n",out_type);
 fprintf(our_outfile,"#dM%d\n",mem_model);
 fprintf(our_outfile,"#d3%d\n",make32);
 if(out_type!=1)fprintf(our_outfile,"#ds%.8lx\n",stack_size);
// fprintf(our_outfile,"#dS%.8lx:%.8lx\n",start_seg,start_offset);
// fprintf(our_outfile,"#ds%.8lx:%.8lx\n",stack_seg,stack_size);
 if(out_type!=1)fprintf(our_outfile,"#dm%.4lx\n",set_mem_max);
return; }

int compilefile(char *fname){//ret 1 if must quit operation      
  int re,skipbit=0;
      if(cur_file!=NULL)fclose(cur_file);
      cur_file=fopen(fname,"r");
      if(cur_file==NULL){ error_cnt++; sprintf(pr_str,"Cannot open %s\n",fname);
                                        print_f(pr_str);
                        total_err++; return 1; }

     if(open_outfile(fname)==0)return 1;

      endof=0; linecntr=0;
      for(;;){
        read_line(0);
        skipbit=0;
   loopplace:
   		re=0;
      	skipspaces();
      	if(curline[lptr]==0);//nothing to do, it's a blank line
      	else if(curline[lptr]==';');//do nothing, it's a rem
      	else if(curline[lptr]=='.') { lptr++;
                                       getnextword();       
                                       do_directive(); }//Directive
        else{ 
      	      getnextword();
      	      if(finddirective(theword)!=-1)do_directive();//lets check if it's a directive again (incase no .)
      	      else if(findmarco(theword)==1) unpackmarco();//it's a marco to unpack
      		  else if(findasmcom(theword)==1){
                                             if(assemble(curline+skipbit)==-1)break;//it's an asm command
                                                                 }
      		  else re=do_label_thing();//label pos,db,equ etc...
      			}
      	if(endof==1){      	
      				if(top_inc==NULL)break; 
      				pop_inc();
      				endof=0;
      				}
      	if(out_of_mem==1)break;
      	if(re==1){ skipbit=lptr; goto loopplace; }
        	}

      fclose(cur_file); cur_file=NULL;

      if(out_of_mem==1)error("Out of Memory",ERROR);
      else check_labels();
      sprintf(pr_str,"Compiled %s (%d Lines)\n",fname,linecntr);
      print_f(pr_str);
      sprintf(pr_str,"%d Error(s) found, %d Warning(s) found\n",error_cnt,warning_cnt);
      print_f(pr_str);

   dump_directives();
   fclose(our_outfile); our_outfile=NULL;

          if(error_cnt==0){ //dump_sob(fname);
	                	if(out_of_mem==1)error("Out of Memory",ERROR);
	  						}

return 0; }


void free_all(){
         free_marcos();
         free_tmpname();
         free_equs();
         free_incs();
         free_labels();
         free_relatives();
//         if(the_code!=NULL){ free(the_code); the_code=NULL; malfreecntr--;  }
        code_size=0; real_code_ptr=code_ptr=0;
return; }

void compilefiles(){
 filehold *tmpf;
 
 defaults();
 while(top_filecomp){
         error_cnt=warning_cnt=0;
         hadoverwarn=0;seg_code_ptr=0;
         if(out_of_mem==1)break;
         if(compilefile(top_filecomp->name)==1)break;

         tmpf=top_filecomp->prev;
         if(top_filecomp->name){ free(top_filecomp->name);
                                   malfreecntr--; }
         free(top_filecomp);
         malfreecntr--;
         top_filecomp=tmpf;
		 free_all();
        }

return; }

void main(int argc, char **argv){
 int a;
 short had1=0;

 if(argc>1)
    for(a=argc-1; a>0; a--){
      if(!stricmp(argv[a],"+H")){had1=2; break; }//help
      else if(!stricmp(argv[a],"+3"))out32=1,make32=1;//32bit
      else if(!stricmp(argv[a],"+C"))mem_model=1, out_type=1;//Com (MUST BE tiny model)
      //else if(!stricmp(argv[a],"+L"))mem_model=1, out_type=2;//LIB file
      else if(!stricmp(argv[a],"+L"))out_type=2;//LIB file
      else if(!stricmp(argv[a],"+M1"))mem_model=1;//model tiny
      else if(!stricmp(argv[a],"+M2"))mem_model=2;//model not tiny(default)
      else if(!stricmp(argv[a],"+S"))case_sensi=1;//model not tiny(default)
      else if(argv[a][0]=='>'){
                        re_dir=1;
                        re_name=argv[a]+1;
                        }
      else {    had1=1;
                if(argv[a][0])if(storefiletocompile(argv[a]))break; }
              }

 if(re_dir){
       re_hnd=fopen(re_name,"w");
       if(re_hnd==NULL)re_dir=0;
        }

 sprintf(pr_str,"SASM %s:\n(c)2001 Snakesoft/Rodney McConnell (snakessoft@yahoo.co.uk, breed@mindless.com)\n",SASM_ver_);
 print_f(pr_str);
 sprintf(pr_str,"Visit the home of snakessoft http://www.geocities.com/snakessoft\n\n");
 print_f(pr_str);
 if(had1==0){ sprintf(pr_str,"Usage: sasm filename.asm     [+H For Help]\n");
                print_f(pr_str);if(re_hnd)fclose(re_hnd); exit(-1); }
 if(had1==2){ 
            sprintf(pr_str,"Optional parameters:\n +3 = 32Bit Output\n"); 
            print_f(pr_str);
            sprintf(pr_str," +C = Com file\n");
            print_f(pr_str);
            sprintf(pr_str," +L = Lib file\n");
            print_f(pr_str);
            sprintf(pr_str," +Mx = Memory Model (x= 1 Tiny, 2=Normal)\n");
            print_f(pr_str);
            sprintf(pr_str,"\nUsage: sasm filename.asm [Optional Parameters]\n");
            print_f(pr_str);
            if(re_hnd)fclose(re_hnd);
            exit(-1);
 					}

 if(out_of_mem==1){ sprintf(pr_str,"Out of Memory...\n"); print_f(pr_str);
                    if(re_hnd)fclose(re_hnd);
                        exit(-1); }


 compilefiles(); 

 sprintf(pr_str,"\nSASM Operation complete: Total lines %d\n",total_linecntr);
 print_f(pr_str);
 sprintf(pr_str,"Total Errors in this Operation %d\n",total_err);
 print_f(pr_str);
 sprintf(pr_str,"Total Warnings in this Operation %d\n",total_warn);
 print_f(pr_str);

 free_storedfilenames();
 free_all();
 if(malfreecntr!=0){ sprintf(pr_str,"Memory Error (%d)\n",malfreecntr);
                     print_f(pr_str);
                     }
 if(re_hnd)fclose(re_hnd);
return; }

