//List of all the assembler commands
//supported by Sasm v3

    char *multi[]={"REP","REPZ","REPE","REPNZ","REPNE","LOCK",NULL };
    	
	struct opcode {char *name; short type; unsigned char first; unsigned char second;};

	struct opcode opcodes[] = {
			   //*** Mov *********************
                               { "MOV"  ,0,0,0 },
			   //*** Jmp/CALL ****************
                               { "JMP"  ,1,0,0 }, 
                               { "CALL" ,1,1,0 }, //Call is almost the same as jmp
			   //*** DEC/div/IDIV/imul/INC/mul/NEG/not *****
                               { "DEC"  ,2,0x08,0 },
                               { "DIV"  ,2,0x30,1 },
                               { "IDIV" ,2,0x38,2 },
                               { "IMUL" ,2,0x28,3 },
                               { "INC"  ,2,0x00,4 },
                               { "MUL"  ,2,0x20,5 },
                               { "NEG"  ,2,0x18,6 },
                               { "NOT"  ,2,0x10,7 },
			   //*** CMPXCHG ****************
                               { "CMPXCHG",3,0,0 },
			   //*** TEST *******************
                               { "TEST" ,4,0,0 },
			    //*** ADC,ADD,SUB,SBB,CMP,AND,OR,XOR *****
                               { "ADC"  ,5,0x10,0 },
                               { "ADD"  ,5,0,   0 },
                               { "SUB"  ,5,0x28,0 },
                               { "SBB"  ,5,0x18,0 },
                               { "CMP"  ,5,0x38,0 },
                               { "AND"  ,5,0x20,0 },
                               { "OR"   ,5,0x8, 0 },
                               { "XOR"  ,5,0x30,0 },
			    // No operand instructions (till 0)
			      //8086=41
                               { "AAA"  ,6,0x37,  0 },
                               { "AAD"  ,6,0xD5,  0x0A },
                               { "AAM"  ,6,0xD4,  0x0A },
                               { "AAS"  ,6,0x3F,  0 },
                               { "CBW"  ,6,0x98,  0 },
                               { "CLC"  ,6,0xF8,  0 },
                               { "CLD"  ,6,0xFC,  0 },
                               { "CLI"  ,6,0xFA,  0 },
                               { "CMC"  ,6,0xF5,  0 },
                               { "CMPSB",6,0xA6,  0 },
                               { "CMPSW",6,0xA7,  0 },
                               { "CWD"  ,6,0x99,  0 },
                               { "DAA"  ,6,0x27,  0 },
                               { "DAS"  ,6,0x2F,  0 },
                               { "HLT"  ,6,0xF4,  0 },
                               { "INTO" ,6,0xCE,  0 },
                               { "IRET" ,6,0xCF,  0 },
                               { "LAHF" ,6,0x9F,  0 },
                               { "LODSB",6,0xAC,  0 },
                               { "LODSW",6,0xAD,  0 },
                               { "MOVSB",6,0xA4,  0 },
                               { "MOVSW",6,0xA5,  0 },
                               { "NOP"  ,6,0x90,  0 },
                               { "POPF" ,6,0x9D,  0 },
                               { "PUSHF",6,0x9C,  0 },
                               { "SAHF" ,6,0x9F,  0 },
                               { "SCASB",6,0xAE,  0 },
                               { "SCASW",6,0xAF,  0 },
                               { "STC"  ,6,0xF9,  0 },
                               { "STD"  ,6,0xFD,  0 },
                               { "STI"  ,6,0xFB,  0 },
                               { "STOSB",6,0xAA,  0 },
                               { "STOSW",6,0xAB,  0 },
                               { "WAIT" ,6,0x9B,  0 },
                               { "XLAT" ,6,0xD7,  0 },
                               { "REP"  ,6,0xF3,  0 }, //from here these want a
                               { "REPZ" ,6,0xF3,  0 }, //follow instruction
                               { "REPE" ,6,0xF3,  0 },
                               { "REPNZ",6,0xF2,  0 },
                               { "REPNE",6,0xF2,  0 },
                               { "LOCK" ,6,0xF0,  0 },
				// 286=8
                               { "LEAVE",6,0xC9,  0 },
                               { "INSB" ,6,0x6C,  0 },
                               { "INSW" ,6,0x6D,  0 },
                               { "POPA" ,6,0x61,  0 },
                               { "PUSHA",6,0x60,  0 },
                               { "OUTSB",6,0x6E,  0 },
                               { "OUTSW",6,0x6F,  0 },
                               { "CLTS" ,6,0x0F,  0x06 },
				// 386=13
                               { "CWDE"  ,6,0x66, 0x98 },
                               { "CDQ"   ,6,0x66, 0x99 },
                               { "CMPSD" ,6,0x66, 0xA7 },
                               { "INSD"  ,6,0x66, 0x6D },
                               { "LODSD" ,6,0x66, 0xAD },
                               { "MOVSD" ,6,0x66, 0xA5 },
                               { "OUTSD" ,6,0x66, 0x6F },
                               { "PUSHAD",6,0x66, 0x60 },
                               { "PUSHFD",6,0x66, 0x9C },
                               { "POPAD" ,6,0x66, 0x61 },
                               { "POPAF" ,6,0x66, 0x9D },
                               { "SCASD" ,6,0x66, 0xAF },
                               { "STOSD" ,6,0x66, 0xAB },
				// 486=(4) 2
                               { "WBINVD",6,0x0F,0x09 },
                               { "INVD"  ,6,0x0F,0x08 },
				//"OPSIZE",0x66
				//"ADRSIZE",0x67
			   //*** ESC *********************
                               { "ESC"   ,7,0   ,0 },
			   //*** INT *********************
                               { "INT"   ,8,0   ,0 },
               //*** IN/OUT *******************
               { "IN"    ,9,0  ,0 },
               { "OUT"   ,9,1  ,0 },
               //*** LDS/LEA/LES/LFS/LGS/LSS ****
               { "LDS"   ,10,0xC5,0 },
               { "LEA"   ,10,0x8D,0 },
               { "LES"   ,10,0xC4,0 },
               { "LFS"   ,10,0xB4,1 },
               { "LGS"   ,10,0xB5,1 },
               { "LSS"   ,10,0xB2,1 },
			   //*** RET/RETF *******************
                           { "RET"   ,11,0xC2,0 },
                           { "RETF"  ,11,0xCA,1 },
			   //*** POP/PUSH *******************
                           { "POP"   ,12,0 ,0 },
                           { "PUSH"  ,12,1 ,0 },
			   //*** XCHG *******************
                           { "XCHG"  ,13,0 ,0 },
			   //*** RCL/RCR/ROL/ROR/(SAL/SHL)/SAR/SHR *******************
                           { "RCL"   ,14,0x10,0 },
                           { "RCR"   ,14,0x18,1 },
                           { "ROL"   ,14,0x00,2 },
                           { "ROR"   ,14,0x08,3 },
                           { "SAL"   ,14,0x20,4 },
                           { "SHL"   ,14,0x20,4 },
                           { "SAR"   ,14,0x38,5 },
                           { "SHR"   ,14,0x28,6 },
			   //*** BOUND *******************
                           { "BOUND" ,15,0   ,0 },
			   //*** ENTER *******************
                           { "ENTER" ,16,0  ,0 },
			   //*** BSF/BSR *******************
                           { "BSF"   ,17,0xBC ,0 },
                           { "BSR"   ,17,0xBD ,0 },
			   //*** BT/BTC/BTR/BTS *******************
                           { "BT"    ,18,0x00 ,0 },
                           { "BTC"   ,18,0x18 ,0 },
                           { "BTR"   ,18,0x10 ,0 },
                           { "BTS"   ,18,0x08 ,0 },
			   //*** MOVSX/MOVZX *******************
                           { "MOVSX" ,19,0xBF ,0 },
                           { "MOVZX" ,19,0xB7 ,0 },
			   //*** (SETNC/SETAE/SETNB)(SETC/SETB/SETNAE)(SETBE/SETNA)(SETE/SETZ)
			   //    (SETNE/SETNZ)(SETL/SETNGE)(SETGE/SETNL)(SETLE/SETNG)(SETG/SETNLE)
			   //    SETS/SETNS/SETO/SETNO/(SETP/SETPE)(SETNP/SETPO) *******************
                          {  "SETNC" ,21,0x93 ,0 }, { "SETAE" ,21,0x93 ,0 }, { "SETNB" ,21,0x93 ,0 },
                          {  "SETC"  ,21,0x92 ,0 }, { "SETB"  ,21,0x92 ,0 }, { "SETNAE",21,0x92 ,0 },
                          {  "SETBE" ,21,0x96 ,0 }, { "SETNA" ,21,0x96 ,0 },
                          {  "SETE"  ,21,0x94 ,0 }, { "SETZ"  ,21,0x94 ,0 },
                          {  "SETNE" ,21,0x95 ,0 }, { "SETNZ" ,21,0x95 ,0 },
                          {  "SETL"  ,21,0x9C ,0 }, { "SETNGE",21,0x9C ,0 },
                          {  "SETGE" ,21,0x9D ,0 }, { "SETNL" ,21,0x9D ,0 },
                          {  "SETLE" ,21,0x9E ,0 }, { "SETNG" ,21,0x9E ,0 },
                          {  "SETG"  ,21,0x9F ,0 }, { "SETNLE",21,0x9F ,0 },
                          {  "SETS"  ,21,0x98 ,0 },
                          {  "SETNS" ,21,0x99 ,0 },
                          {  "SETO"  ,21,0x90 ,0 },
                          {  "SETNO" ,21,0x91 ,0 },
                          {  "SETP"  ,21,0x9A ,0 }, { "SETPE" ,21,0x9A ,0 },
                          {  "SETNP" ,21,0x9B ,0 }, { "SETPO" ,21,0x9B ,0 },
			   //*** SHLD/SHRD *******************
                          {  "SHLD"  ,22,0xA4 ,0 },
                          {  "SHRD"  ,22,0xAC ,0 },
			   //*** BSWAP *******************
                          {  "BSWAP" ,23 ,0   ,0 },
			   //*** INVLPG *******************
                          {  "INVLPG",24 ,0   ,0 },
			   //*** LGDT/LIDT/SGDT/SIDT *******************
                          {  "LGDT"  ,25 ,0x10,0 },
                          {  "LIDT"  ,25 ,0x18,0 },
                          {  "SGDT"  ,25 ,0x00,0 },
                          {  "SIDT"  ,25 ,0x08,0 },
			   //*** LLDT/LMSW/LTR/SLDT/SMSW/STR *******************
                              {  "LLDT"  ,26 ,0   ,0x10 },
                              {  "LMSW"  ,26 ,1   ,0x30 },
                              {  "LTR"   ,26 ,0   ,0x18 },
                              {  "SLDT"  ,26 ,0   ,0 },
                              {  "SMSW"  ,26 ,1   ,0x20 },
                              {  "STR"   ,26 ,0   ,0x8 },
			   //*** ARPL *******************
			   //*** LSR/LSL *******************
                           { "ARPL"  ,27 ,0   ,0 },
                           { "LSR"   ,27 ,2   ,0 },
                           { "LSL"   ,27 ,3   ,0 },
			   //*** VERR/VERW *******************
                           { "VERR"  ,28 ,20   ,0 },
                           { "VERW"  ,28 ,28   ,0 },
			   //*** COnditional jumps *******
                               { "JA"    ,20,0x77,0 },
                               { "JNBE"  ,20,0x77,0 },
                               { "JAE"   ,20,0x73,0 },
                               { "JNB"   ,20,0x73,0 },
                               { "JNC"   ,20,0x73,0 },
                               { "JB"    ,20,0x72,0 },
                               { "JNAE"  ,20,0x72,0 },
                               { "JC"    ,20,0x72,0 },
                               { "JBE"   ,20,0x76,0 },
                               { "JNA"   ,20,0x76,0 },
                               { "JCXZ"  ,20,0xE3,0 },
                               { "JE"    ,20,0x74,0 },
                               { "JZ"    ,20,0x74,0 },
                               { "JG"    ,20,0x7F,0 },
                               { "JNLE"  ,20,0x7F,0 },
                               { "JGE"   ,20,0x7D,0 },
                               { "JNL"   ,20,0x7D,0 },
                               { "JL"    ,20,0x7C,0 },
                               { "JNGE"  ,20,0x7C,0 },
                               { "JLE"   ,20,0x7E,0 },
                               { "JNG"   ,20,0x7E,0 },
                               { "JNE"   ,20,0x75,0 },
                               { "JNZ"   ,20,0x75,0 },
                               { "JO"    ,20,0x70,0 },
                               { "JNO"   ,20,0x71,0 },
                               { "JS"    ,20,0x78,0 },
                               { "JNS"   ,20,0x79,0 },
                               { "JNP"   ,20,0x7B,0 },
                               { "JPO"   ,20,0x7B,0 },
                               { "JP"    ,20,0x7A,0 },
                               { "JPE"   ,20,0x7A,0 },
                               { "LOOP"  ,20,0xE2,1 },//this 1 means 8bit only
                               { "LOOPE" ,20,0xE1,1 },
                               { "LOOPZ" ,20,0xE1,1 },
                               { "LOOPNE",20,0xE0,1 },
                               { "LOOPNZ",20,0xE0,1 },
//FLOATING POINT COMMANDS
				// No operand instructions (till 0) (as 6)
                               { "FABS"   ,6,0xD9,0xE1 },
                               { "FCHS"   ,6,0xD9,0xE0 },
                               { "FCLEX"  ,6,0xDB,0xE2 },
                               { "FDECSTP",6,0xD9,0xF6 },
                               { "FDISI"  ,6,0xDB,0xE1 },
                               { "FENI"   ,6,0xDB,0xE0 },
                               { "FINCSTP",6,0xD9,0xF7 },
                               { "FINIT"  ,6,0xDB,0xE3 },
                               { "FLDLG2" ,6,0xD9,0xEC },
                               { "FLDLN2" ,6,0xD9,0xED },
                               { "FLDL2E" ,6,0xD9,0xEA },
                               { "FLDL2T" ,6,0xD9,0xE9 },
                               { "FLDPI"  ,6,0xD9,0xEB },
                               { "FLD2"   ,6,0xD9,0xEE },
                               { "FLD1"   ,6,0xD9,0xE8 },
                               { "FNOP"   ,6,0xD9,0xD0 },
                               { "FPATAN" ,6,0xD9,0xF3 },
                               { "FPREM"  ,6,0xD9,0xF8 },
                               { "FPTAN"  ,6,0xD9,0xF2 },
                               { "FRNDINT",6,0xD9,0xFC },
                               { "FSCALE" ,6,0xD9,0xFD },
                               { "FSETPM" ,6,0xDB,0xE4 },
                               { "FSQRT"  ,6,0xD9,0xFA },
                               { "FTST"   ,6,0xD9,0xE4 },
                               { "FWAIT"  ,6,0x9B,0 },
                               { "FXAM"   ,6,0xD9,0xE5 },
                               { "FXTRACT",6,0xD9,0xF4 },
                               { "FYL2X"  ,6,0xD9,0xF1 },
                               { "FYL2XP1",6,0xD9,0xF9 },
                               { "F2XM1"  ,6,0xD9,0xF0 },
                               { "FCOS"   ,6,0xD9,0xFF },
                               { "FSIN"   ,6,0xD9,0xFE },
                               { "FPREM1" ,6,0xD9,0xF5 },
                               { "FSINCOS",6,0xD9,0xFB },
               //*** Fadd//Fsub/Fsubr/Fmul/Fdiv/Fdivr ***********
               { "FADD"   ,29,0   ,0 },
               { "FSUB"   ,29,0x20,0x28 },
               { "FSUBR"  ,29,0x28,0x20 },
               { "FMUL"   ,29,0x08,0x08 },
               { "FDIV"   ,29,0x30,0x38 },
               { "FDIVR"  ,29,0x38,0x30 },
               //*** Faddp/Fsubp/Fsubrp/Fmulp/Fdivp/fdivrp *****
               { "FADDP"  ,30,0    ,0 },
               { "FSUBP"  ,30,0x28 ,0 },
               { "FSUBRP" ,30,0x20 ,0 },
               { "FMULP"  ,30,0x8  ,0 },
               { "FDIVP"  ,30,0x38 ,0 },
               { "FIDVRP" ,30,0x30 ,0 },
               //*** Fisubr/Fidivr/Fiadd/Fidiv/Fild/Fimul/Fist/Fistp/Fisub/Fstcw ****
               { "FISUBR" ,31,0x28 ,1 },
               { "FIDIVR" ,31,0x38 ,1 },
               { "FIADD"  ,31,0    ,1 },
               { "FIDIV"  ,31,0x30 ,1 },
               { "FILD"   ,31,0    ,2 },
               { "FIMUL"  ,31,8    ,1 },
               { "FIST"   ,31,0x10 ,2 },
               { "FISTP"  ,31,0x18 ,2 },
               { "FISUB"  ,31,0x20 ,1 },
               { "FSTCW"  ,31,0x38 ,3 },
               //*** Fldenv/Fstenv
               { "FLDENV" ,32,0    ,0 },
               { "FSTENV" ,32,0x10 ,0 },
               //*** fcom/fcomp/fcompp/ffree/fst/fstp/fxch ******
               { "FCOM"   ,33,0xD8 ,0xD0 }, //
               { "FCOMP"  ,33,0xD8 ,0xD8 }, //
               { "FCOMPP" ,33,0xDE ,0xD8 },
               { "FFREE"  ,33,0xDD ,0xC0 },
               { "FST"    ,33,0xDD ,0xD0 }, //
               { "FSTP"   ,33,0xDD ,0xD8 }, //
               { "FXCH"   ,33,0xD9 ,0xD9 }, 
               //*** Fbld/fbstp *****
               { "FBLD"   ,34,0    ,0 },
               { "FBSTP"  ,34,0x10 ,0 },
               //*** FLD *************
               { "FLD"    ,35,0    ,0 },

                               { NULL,0,0,0 } };


